function main(edgefile, isdir)

    edgefile = 'asker_answerer_count.csv';
    
    % feature extraction
    tic
    trackAll( edgefile, isdir );
    toc
    
    % features = [egonetN egonetE egonetW egonetInD egonetOutD egonetInW egonetOutW egoInD egoOutD egoInW egoOutW egonetMaxW egoMaxInW egoMaxOutW numneighdeg1];
    % features = [egonetN egonetE egonetW egonetD egonetBW egoW egonetMaxW egoMaxW numneighdeg1];  
   
    plottitle = 'STACK'; 

    pattern(edgefile,strcat(edgefile,'_features_all.txt'), [1 2], {'#nodes','#edges'}, 20, 0, 1, 1, plottitle , 1, '', 5)
    pattern(edgefile,strcat(edgefile,'_features_all.txt'), [2 3], {'#edges','weight'}, 20, 0, 4, 1, plottitle , 1, '', 5)
    

       
    if(isdir)
        pattern(edgefile,strcat(edgefile,'_features_all.txt'), [5 7], {'egonet-out-degree','egonet-out-weight'}, 20, 0, 4, 1, plottitle , 1, '', 5)
        pattern(edgefile,strcat(edgefile,'_features_all.txt'), [4 6], {'egonet-in-degree','egonet-in-weight'}, 20, 0, 4, 1, plottitle , 1, '', 5)
        pattern(edgefile,strcat(edgefile,'_features_all.txt'), [9 11], {'ego-out-degree','ego-out-weight'}, 20, 0, 4, 1, plottitle , 1, '', 5)
        pattern(edgefile,strcat(edgefile,'_features_all.txt'), [8 10], {'ego-in-degree','ego-in-weight'}, 20, 0, 4, 1, plottitle , 1, '', 5)
	 pattern(edgefile,strcat(edgefile,'_features_all.txt'), [3 12], {'egonet-weight','egonet-max-weight'}, 20, 0, 4, 1, plottitle , 1, '', 5)   
        pattern(edgefile,strcat(edgefile,'_features_all.txt'), [10 13], {'ego-inweight','ego-max-inweight'}, 20, 0, 4, 1, plottitle , 1, '', 5)       
	 pattern(edgefile,strcat(edgefile,'_features_all.txt'), [11 14], {'ego-outweight','ego-max-outweight'}, 20, 0, 4, 1, plottitle , 1, '', 5)       
        pattern(edgefile,strcat(edgefile,'_features_all.txt'), [1 15], {'#nodes','#neighbors_{deg=1}'}, 20, 0, 4, 1, plottitle , 1, '', 5)

    else
         pattern(edgefile,strcat(edgefile,'_features_all.txt'), [1 4], {'#nodes','egonet-degree'}, 20, 0, -1, 1, plottitle , 1, '', 5)
         pattern(edgefile,strcat(edgefile,'_features_all.txt'), [4 5], {'egonet-degree','egonet-weight'}, 20, 0, -1, 1, plottitle , 1, '', 5)
         pattern(edgefile,strcat(edgefile,'_features_all.txt'), [1 6], {'ego-degree','ego-weight'}, 20, 0, -1, 1, plottitle , 1, '', 5)
         pattern(edgefile,strcat(edgefile,'_features_all.txt'), [3 7], {'egonet-weight','egonet-max-weight'}, 20, 0, 4, 1, plottitle , 1, '', 5)   
	  pattern(edgefile,strcat(edgefile,'_features_all.txt'), [6 8], {'ego-weight','ego-max-weight'}, 20, 0, 4, 1, plottitle , 1, '', 5)
	  pattern(edgefile,strcat(edgefile,'_features_all.txt'), [1 9], {'#nodes','#neighbors_{deg=1}'}, 20, 0, 4, 1, plottitle , 1, '', 5)


    end

end