function pattern(edgefilename,featfilename, props, labels, k, istext, limits, isline, figtitle, print, dir, TOP)


[src dst w] = textread(edgefilename,'','delimiter',',');
%[src dst] = textread(edgefilename);
%src = src+1;
%dst = dst+1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ids = [src; dst]; clear src; clear dst; clear w;
unodeids = unique(ids);
length(unodeids)
clear ids;

data2 = textread(featfilename); % nn 
data2 = data2(unodeids,:);
indx = find( data2(:,props(1)) > 0 & data2(:,props(2)) > 0 ); % ignore negative or 0 valued nodes
edge_w = ceil(data2(indx,props(1)));
mul_deg = ceil(data2(indx,props(2)));
nodeids = unodeids(indx);
clear data2;
length(nodeids)


%labels = {'N_1', 'E_1', 'in-degree',  'in-weight', 'out-degree', 'out-weight', 'avg-in-weight', 'max-in-weight', 'avg-out-weight', 'max-out-weight' };

%han = figure('visible','off')




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if (isline)
% bucketize
mult = 1;
base = 2;
buc = 0;

% find number of buckets
sumin = 1;
maxx = max(edge_w-min(edge_w)+1);
while (sumin < maxx)
    sumin = sumin + (base^buc) * mult;
    buc = buc+1;
end

middledegrees = zeros(buc,1);
mediandeg = zeros(buc,1);

bucno = 0;
start = min(edge_w);
cur = 1;
%avgnumnodesinbucks = 0;
%count = 0;
for t=1:buc
    endd = start+ (base^bucno) * mult;

    indices = find(  edge_w >= start & edge_w < endd  );
    
    if ( ~isempty(indices) )        
        m = mul_deg(indices);
        curedge_w = edge_w(indices);

        med = median(  m ) ;          
        [min_difference, in_indices] = min(abs(m - med));        
        mediandeg(cur) = m(in_indices(1));

        [sm si] = sort(m);
        curedge_w = curedge_w(si);
        mid = ceil(length(indices)/2);
        in_indices2 = find(sm == mediandeg(cur));
        [min_difference, medind] = min(abs(in_indices2 - mid));
        middledegrees(cur) = curedge_w(in_indices2(medind(1))); %(start+endd)/2;

        cur = cur+1;
        
        %length(indices)
        %if(length(indices) >= 200)
        %    count=count+1;
            %avgnumnodesinbucks = (avgnumnodesinbucks+length(indices))/count;            
        %end
        
    end
    start = endd;
    bucno = bucno+1;
end
%count
%numnonemptybucs = cur-1;
%numnonemptybucs2 = count;
%middledegrees2 = middledegrees(1:numnonemptybucs2);
%mediandeg2 = mediandeg(1:numnonemptybucs2);


%middledegrees = middledegrees(1:numnonemptybucs);
%mediandeg = mediandeg(1:numnonemptybucs);

ind = find(mediandeg >0 & middledegrees>0);
mediandeg = mediandeg(ind);
middledegrees = middledegrees(ind);


Y = (log10(mediandeg));
t = (log10(middledegrees));
%wi = [ones(length(t),1) t]\Y
X = [ones(length(t),1) t];
T= inv(X'*X)*X';
H = X*T;
hiis = diag(H);

wi = T*Y;
y = wi(2) * t + wi(1);

middledegrees2 = middledegrees;
mediandeg2 = mediandeg;

while(1)
% compute Cook's distance of median points
RSS = sum((Y-y).^2);
sigmasqr = RSS/(length(t)-2);
cooksD = ( (Y-y).^2 .* hiis) ./ (2* sigmasqr * (1-hiis).^2);

%cookMean = mean(cooksD);
%cookStd = std(cooksD);

% if there is a point with cooksD >=1, drop it and refit
figure; hold on
bar(1:1:length(t), cooksD)
line(1:1:length(t), repmat(1, length(t),1))


ind = find(cooksD>=1);
if(length(ind)==0)
    break;
end
%else
middledegrees2(ind) = [];
mediandeg2(ind) = [];

Y = (log10(mediandeg2));
t = (log10(middledegrees2));
%wi = [ones(length(t),1) t]\Y
X = [ones(length(t),1) t];
T= inv(X'*X)*X';
H = X*T;
hiis = diag(H);

wi = T*Y;
y = wi(2) * t + wi(1);
end

t = (log10(middledegrees));
y = wi(2) * t + wi(1);


h=figure
hold all

title(figtitle, 'FontSize', 16)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dcm_obj = datacursormode(h);
set(dcm_obj,'SnapToDataVertex','off','Enable','on', 'UpdateFcn',@myupdatefcn)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
loglog( 10.^log10(middledegrees), 10.^y, 'r-', 'LineWidth',2 )
legendss{1} = strcat( num2str(wi(2)) , 'x + (' , num2str(wi(1)), ') = y' ); 

if (limits == 1) % for E vs N
    % TREE-LIKE
    t = (log10(middledegrees2));
    Y = (log10(middledegrees2-1));
    w = [ones(length(t),1) t]\Y;
    y2 = w(2) * log10(middledegrees) + w(1);    
    loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 

    % CLIQUE
    t = (log10(middledegrees2));
    Y = (log10(((middledegrees2-1).*middledegrees2 / 2) + middledegrees2)); % +1 for self-loops
    w = [ones(length(t),1) t]\Y;
    y3 = w(2) * log10(middledegrees) + w(1);   
    loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
    legendss{3} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 
end
if (limits == 2) % for lambda_1 vs E
    % STAR
    t = (log10(middledegrees2));
    Y = (log10(sqrt(middledegrees2)));
    w = [ones(length(t),1) t]\Y;
    y2 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 

    % CLIQUE
    t = (log10(mediandeg2.*(mediandeg2+1)/2));
    Y = (log10(mediandeg2));
    w = [ones(length(t),1) t]\Y;
    y3 = w(2) * log10(middledegrees) + w(1);
    loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
    legendss{3} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 
    
   
end


if (limits == 3) % for lambda_w1 vs W
    % uniform slope = 0.5
    t = (log10(middledegrees2));
    Y = (log10(sqrt(middledegrees2)));
    w = [ones(length(t),1) t]\Y;
    y2 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 

    % 1 burst slope = 1
    t = (log10(middledegrees2));
    H = (log10(middledegrees2));
    w = [ones(length(t),1) t]\Y;
    y3 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
    legendss{3} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' );  
    
   
end

if (limits == 4) % for W vs E
 
    t = (log10(middledegrees2));
    H = (log10(middledegrees2));
    w = [ones(length(t),1) t]\H;
    y2 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' );  
    
   
end

legend(legendss, 'FontSize', 12,2)

loglog(edge_w,mul_deg,... %'g.') %,'color',[0 1 0]*0.8)
    'LineStyle','none','Marker','o','MarkerSize',4,'MarkerEdgeColor','g','MarkerFaceColor','g');
loglog(  middledegrees, mediandeg, 'o','Markersize',6, 'MarkerEdgeColor','k',...
              'MarkerFaceColor','k');
loglog(  middledegrees2, mediandeg2, 'o','Markersize',5, 'MarkerEdgeColor','b',...
              'MarkerFaceColor','b');
loglog( 10.^log10(middledegrees), 10.^y, 'r-', 'LineWidth',3 )             
if (limits < 4 && limits > 0)   
loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',2 )
loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',2 )
end
if (limits == 4)   
loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',2 )
end


% % put bucket signs!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
% start = min(edge_w);
% bucno = 0;
% for t=1:buc
%     endd = start+ (base^bucno) * mult;
%     yl = ylim;
%     q = ones(yl(2),1);
%     q = cumsum(q);
%     q2 = ones(yl(2),1);
%     q2 = q2*endd;
%     line(q2,q,'color',[.7,.7,.7], 'Linestyle',':', 'LineWidth',.5 ) 
%     
%     start = endd;
%     bucno = bucno+1;
% end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% find the top-k most away from below and above from the fitting line

differ = zeros(length(nodeids),1);


%fid = fopen( strcat(filename,'_',num2str(props(1)),'_',num2str(props(2)),'_scores_p'), 'w');

for i=1:length(nodeids)
    
       	r = (mul_deg(i) / (  (edge_w(i))^wi(2) * 10^wi(1) ));
        dif = abs( (mul_deg(i) - (  (edge_w(i))^wi(2) * 10^wi(1) )) );
        if(dif<1)
            differ(i) = 0;
        else
            differ(i) = max( r, 1/r) * log10(dif); 
        end
       	%fprintf(fid,'%s %s\n', num2str(data(d,1)), num2str( differ(siz2ind) )); 
       
    
end

%fclose(fid);



[sortdiffer ind] = sort(differ,'descend');
[usortdiffer ind2] = unique(sortdiffer);


dlmwrite(strcat(dir, 'tops/', edgefilename,'_', num2str(props(1)),'_',num2str(props(2)),'_IDandScoreSorted.txt'),[nodeids(ind) sortdiffer], 'delimiter',' ');


ind = ind(ind2);
siz = length(usortdiffer);

if(siz<k)
    k=siz;
end
nodeind = ind(siz-k+1:siz) ;
%usortdiffertop = usortdiffer(siz-k+1:siz);
%[edge_w(nodeind) mul_deg(nodeind)]
loglog(  edge_w(nodeind), mul_deg(nodeind),...
                'LineStyle','none','marker','^','markersize',6,'MarkerEdgeColor','r','MarkerFaceColor','r')
plot(edge_w(nodeind(k)), mul_deg(nodeind(k)), ...
    'LineStyle','none','marker','^','markersize',12,'MarkerEdgeColor','k','MarkerFaceColor','k')
plot(edge_w(nodeind(k-1)), mul_deg(nodeind(k-1)), ...
    'LineStyle','none','marker','^','markersize',10,'MarkerEdgeColor','b','MarkerFaceColor','b')
plot(edge_w(nodeind(k-2)), mul_deg(nodeind(k-2)), ...
    'LineStyle','none','marker','^','markersize',8,'MarkerEdgeColor','m','MarkerFaceColor','m')

if(istext)            
    text(edge_w(nodeind), mul_deg(nodeind),num2str(nodeids(nodeind)))    
end


% find the top-5 on each axis
[sedge_w ind] = sort(edge_w,'descend');
[smul_deg ind2] = sort(mul_deg,'descend');

topson2dims = unique([ind(1:TOP); ind2(1:TOP)]);
[p r s] = intersect(topson2dims , nodeind);
topson2dims(r) = [];

loglog(  edge_w(topson2dims), mul_deg(topson2dims),...
      'LineStyle','none','marker','v','markersize',7,'MarkerEdgeColor','b','MarkerFaceColor','b')

if(print)        
    
    fid2 = fopen( strcat(dir, 'tops/', edgefilename,'_', num2str(props(1)),'_',num2str(props(2)),'_top_',num2str(k+5),'.txt'), 'w');
    
    
    %fprintf(fid2, '---%s\n', num2str(length(topson2dims)));
    for t=k:-1:1
        fprintf(fid2,'%s %s %s\n', num2str(nodeids(nodeind(t))), num2str(edge_w( nodeind(t) )), num2str(mul_deg( nodeind(t) )) );     
    end
    for t=1:length(topson2dims)
        fprintf(fid2,'%s %s %s\n', num2str(nodeids(topson2dims(t))), num2str(edge_w( topson2dims(t) )), num2str(mul_deg( topson2dims(t) )) ); 
    end
    fclose(fid2);
end



else
    loglog(edge_w, mul_deg,... %'g.') %,'color',[0 1 0]*0.8)
    'LineStyle','none','Marker','o','MarkerSize',2,'MarkerEdgeColor','g','MarkerFaceColor','g');
end
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set(gca,'XScale','log')
set(gca,'YScale','log')
set(gca,'FontSize',12)
xlabel(labels{1},'FontSize', 16)
ylabel(labels{2},'FontSize', 16)
grid on

if(print)
set(gcf,'PaperPositionMode','auto')
saveas(gcf, strcat(dir,'plots/',edgefilename,'_pattern_',num2str(props(1)),'_',num2str(props(2)), '_anomalies.png'))
end
%hgsave(strcat(dir,'plots/',filename,'_pattern_',num2str(props(1)),'_',num2str(props(2)), '.fig'))
%print(han, '-dpng', 'Test');
%close(han);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function txt = myupdatefcn(empt,event_obj)
pos = get(event_obj,'Position');
indd = find( edge_w == pos(1) & mul_deg == pos(2) );
txt = {num2str(nodeids(indd))};
%text(pos(1),pos(2),txt)
plot(pos(1),pos(2),'b.','marker','o','markersize',6)
% fid = fopen( namen, 'a');
% for g=1:length(indd)
%    fprintf(fid,'%s\n', num2str(datum(indd(g),3)) ); 
% end
% 
% fclose(fid);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

end
